#include <iostream.h>
#include <stdlib.h>
#include <afx.h>
#include <windows.h>
#include <conio.h>

#define ERR_ENVIRON_NOT_FOUND  1
#define ERR_FILE_NOT_FOUND     2
#define ERR_FILE_NOT_RIGHT     3
#define ERR_COPY_ERROR         4
#define ERR_UNKNOWN            255

BOOL isfilerequired(PWIN32_FIND_DATA finder);
BOOL isfilefound(CString filename, int *enumbuf);
int getkey(void);

int main(void)
{
    CString tpathname;
    char *cptr;
    int errnum = 0;
    CString systype;
	CString tfilepath;

    cptr = getenv("SystemRoot");
    if( cptr == NULL )
    {
        // try to find "windir"
        cptr = getenv("windir");
        if( cptr == NULL )
        {
            errnum = ERR_ENVIRON_NOT_FOUND; goto glhandler;
        }
        else
        {
            systype = "9x";
        }
    }
    else
    {
        systype = "NT";
    }
    tpathname = cptr;
    tpathname += "\\ShellNew";
    cout << "You are currently running Windows " << systype << "." << endl;
    cout << "This package will be installed to " << tpathname << "." << endl;
    if( !isfilefound("defaultHTML.htm", &errnum) )
    {
        goto glhandler;
    }
    if( !isfilefound("newHtm.reg", &errnum) )
    {
        goto glhandler;
    }

    // copy the file
    tfilepath = tpathname + "\\defaultHTML.htm";
    if( !CopyFile("defaultHTML.htm", tfilepath.GetBuffer(0), FALSE) )
    {
        errnum = ERR_UNKNOWN; goto glhandler;
    }
    cout << "If you see Registry Editor asking you whether to import newHtm.reg" << endl;
    cout << "into the registry, please choose yes." << endl;
    cout << endl;
    cout << "Press any key to continue . . ." << endl;
    getkey();
    system("regedit.exe newHtm.reg");
    goto glfinally;
glhandler:
    switch( errnum )
    {
    case ERR_ENVIRON_NOT_FOUND:
        cout << "Environment variable not found!" << endl;
        break;
    case ERR_FILE_NOT_FOUND: // pass on to ERR_FILE_NOT_FOUND
    case ERR_FILE_NOT_RIGHT:
        cout << "Necessary files missing!" << endl;
        break;
    case ERR_COPY_ERROR:
		cout << "Error copying files!" << endl;
		break;
	case ERR_UNKNOWN:
        cout << "Unknown error occurred!" << endl;
		break;
    }
glfinally:
    return errnum;
}

BOOL isfilefound(CString filename, int *enumbuf)
{
	WIN32_FIND_DATA finder;
	HANDLE handle;
    handle = FindFirstFile(filename.GetBuffer(0), &finder);
    if( handle == INVALID_HANDLE_VALUE  )
    {
        *enumbuf = ERR_FILE_NOT_FOUND; return FALSE;
    }
    if( FindClose(handle) == FALSE )
    {
        *enumbuf = ERR_UNKNOWN; return FALSE;
    }
    if( !isfilerequired(&finder) )
    { // not meeting file requirements
        *enumbuf = ERR_FILE_NOT_RIGHT; return FALSE;
    }
    return TRUE;
}

BOOL isfilerequired(PWIN32_FIND_DATA finder)
{
    if( finder->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY != 0 ||
        finder->dwFileAttributes & FILE_ATTRIBUTE_HIDDEN != 0 ||
        finder->dwFileAttributes & FILE_ATTRIBUTE_SYSTEM != 0 ||
        finder->dwFileAttributes & FILE_ATTRIBUTE_OFFLINE != 0 ||
        finder->dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY != 0 )
    {
        return FALSE;
    }
    else
    {
        return TRUE;
    }
}

int getkey(void)
{
	int ch;
	ch = getch();
	if( ch == 0x00 || ch == 0xE0 )
	{
		ch = getch() << 8;
	}
	return ch;
}
