#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mbstring.h>
#include <windows.h>

long LongGetC(FILE *stream);

typedef unsigned char uchar_t;

enum { STRLEN = 1024 };
uchar_t str[STRLEN];
const int TRUE = 1;
const int FALSE = 0;

void main(int argc, uchar_t **argv)
{
    int i;
    long ch;
    int sc; // space count
    FILE *ifp;
    FILE *ofp;
    enum { ST_NORMAL, ST_SPACEPENDING } status;
    int loopstat;    // state machine loop again flag

    if (argc >= 2)
    {
        strncpy(str, argv[1], STRLEN);
        i = strlen(str) - 4; // try to point to the starting of ".txt"
        if (i < 0)
        {
            printf("Input file must be a .TXT file!\n");
            return;
        }
        if (stricmp(str + i, ".txt") != 0)
        {
            printf("Input file must be a .TXT file!\n");
            return;
        }
        strcpy(str + i, ".htm"); // replace ".txt" with ".htm"
        if ((ifp = fopen(argv[1], "r")) == NULL ||
            (ofp = fopen(str, "w")) == NULL)
        {
            printf("Error opening file(s)!\n");
            if (ifp)
            {
                fclose(ifp);
            }
            if (ofp)
            {
                fclose(ofp);
            }
            return;
        }
        fprintf(ofp, "<html>\n<body>\n");
        sc = 0;
        status = ST_NORMAL;
        while ((ch = LongGetC(ifp)) != -1)
        {
            loopstat = FALSE;
            do
            {
                switch (status)
                {
                case ST_NORMAL:
                    loopstat = FALSE;
                    switch ((uchar_t)ch)
                    {
                    case '&':
                        fprintf(ofp, "&amp;");
                        break;
                    case '<':
                        fprintf(ofp, "&lt;");
                        break;
                    case '>':
                        fprintf(ofp, "&gt;");
                        break;
                    case '\n':
                        fprintf(ofp, "<br>\n");
                        break;
                    case ' ':
                        status = ST_SPACEPENDING;
                        loopstat = TRUE;
                        break;
                    default:
                        // if there is a high byte
                        if ((ch & 0xFF00) != 0)
                        {
                            putc((uchar_t)(ch >> 8), ofp);
                        }
                        putc((uchar_t)ch, ofp);
                        break;
                    }
                    break;
                case ST_SPACEPENDING:
                    if (ch == ' ')
                    {
                        sc++;
                        loopstat = FALSE;
                    }
                    else
                    {
                        sc--;
                        for (i = 0; i < sc; i++)
                        {
                            fprintf(ofp, "&nbsp;");
                        }
                        putc(' ', ofp);
                        sc = 0;
                        status = ST_NORMAL;
                        loopstat = TRUE;
                    }
                    break;
                }
            } while (loopstat);
        }
        if (sc > 0)
        {
            sc--;
            for (i = 0; i < sc; i++)
            {
                fprintf(ofp, "&nbsp;");
            }
            putc(' ', ofp);
        }
        fprintf(ofp, "\n</body>\n</html>\n");
        fclose(ifp);
        fclose(ofp);
    }
    else
    {
        printf("Usage: TXTTOHTM filename.TXT\n");
        printf("\n");
        printf("filename - the name of the text file.");
    }
}

long LongGetC(FILE *stream)
{
    long ch;
    long ch2;

    ch = fgetc(stream);
    if (ch == -1)
    {
        return -1;
    }
    if (IsDBCSLeadByte((uchar_t)ch))
    {
        ch2 = fgetc(stream);
        if (ch2 == -1)
        {
            return ch;
        }
        return (ch << 8) | ch2;
    }
    return ch;
}
